      SUBROUTINE derivs(time,conc,f)
c
c  subroutine to calculate the rates of formation of each of the species
c
      REAL time,conc(*),f(*)	
	REAL k6,k2,k3
	COMMON /rates/k6,k2,k3

c
c  F(1) is the rate of formation of species one
c

      f(1)= -k6*conc(1)+k2*conc(2)
      f(2)=k6*conc(1)-k2*conc(2)-k3*conc(2)
      f(3)=k3*conc(2)
      return
      END



      SUBROUTINE jacobn(time,conc,dfdt,dfdc,n,nmax)
      INTEGER n,nmax,i

      REAL time,conc(*),dfdt(*),dfdc(nmax,nmax)
      REAL k6,k2,k3
	COMMON /rates/k6,k2,k3

	do 11 i=1,3
        dfdt(i)=0.
c
c   dfdt is the df(i)/dt
c
11    continue

c
c  dfdc(i,j) is df(i)/dc(j)
c  so dfdc(1,2) is the derivative of df(1)/dc(2)
c  

      dfdc(1,1)=-k6
      dfdc(1,2)=k2
      dfdc(1,3)=0.0
      dfdc(2,1)=k6
      dfdc(2,2)=-(k2+k3)
      dfdc(2,3)=0.0
      dfdc(3,1)=0.0
      dfdc(3,2)=k3
      dfdc(3,3)=0.0
      return
      END

